/*
 * Canvas Game Library
 * Module: Tile
 * 
 * Copyright Chainsawrus Wreaks 2011
 * All rights reserved.
 */

/**
 * @fileOverview A module that adds basic tilemap capabilities to CGL, will have import/export functions when
 * used with the AJAX module!
 */

/**
 * Tile module namespace
 * @namespace CGL.tile
 */

CGL.tile = {
	Tile : function() {
		var tile = {
			id : 0,
			data : null,
			
			init : function(uid) {
				tile.id = uid;
			},
			
			setId : function(srcdata) {
				tile.id = srcdata;
			},
			
			getId : function() {
				return tile.id;
			}
		};
		return tile;
	}
};

CGL.tile.map = {
	TileMap : function(c, r) {
		var tilemap = {
			cols : c,
			rows : r,
			tiles : new Array(c),
			
			init : function() {
				var iter = 0;
				for(var i = 0; i < tilemap.tiles.length; i++)
				{
					tilemap.tiles[i] = new Array(tilemap.rows);
				}
				
				for(var i = 0; i < tilemap.tiles.length; i++)
				{
					for(var j = 0; j < tilemap.tiles[i].length; j++)
					{
						tilemap.tiles[i][j] = new CGL.tile.Tile();
						//tilemap.tiles[i][j].init(iter);
						//iter += 1;
					}
				}
			},
		
			setTileId : function(tilex, tiley, id) {
				tilemap.tiles[tilex][tiley].setId(id);
			},
			
			getTileId : function(tilex, tiley) {
				return tilemap.tiles[tilex][tiley].getId();
			}
		};
		return tilemap;
	}
};