/*
 * Ludum Dare #22 - Alone
 * 
 * Copyright Chainsawrus Wreaks 2011
 * All rights reserved.
 */

/**
 * @fileOverview Namespace holder for the game Alone for Ludum Dare Challenge #22, I will probably start
 * writing the basics here and then split the game up in smaller chunks.
 * 
 * @todo Come up with a good game idea on the topic Alone!
 */

/**
 * Ludum Dare #22 namespace
 * @namespace LD
 */
LD.game = {
	GAME_STATE : 0,
	PLAYER : null,
	ENEMYZONE : null,
	SHOP : null,
	DOG : null,
	MI_GO : null,
	TREASURE : null,
	SHOP_OPEN : false,
	WEAPON : 0,
	ACTIVEX : 0,
	ACTIVEY : 0,
	LOADED : false,
		
	BTN_newgame : new CGL.ui.Button(192, 240, 256, 72),
	BTN_difficulty : new Array(3),
	BTN_shopitem : new Array(3),
	BTN_about : new CGL.ui.Button(192, 344, 256, 72),
	BTN_shop : new CGL.ui.Button(520, 428, 112, 48),
	BTN_nextLvl : new CGL.ui.Button(512, 384, 128, 128, "Go home!"),
	
	RADIO_weapon : new CGL.ui.Radio(),
	RB_shell : new CGL.ui.RadioButton(512, 128, 128, 128),
	RB_grenade : new CGL.ui.RadioButton(512, 256, 128, 128),
	
	IMG_loading : new CGL.image.Image(),
	IMG_splash : new CGL.image.Image(),
	
	IMG_shell : new CGL.image.Image(),
	IMG_shell_active : new CGL.image.Image(),
	IMG_grenade : new CGL.image.Image(),
	IMG_grenade_active : new CGL.image.Image(),
	IMG_dog : new CGL.image.Image(),
	IMG_statusbar : new CGL.image.Image(),
	IMG_statusback : new CGL.image.Image(),
	IMG_sideback : new CGL.image.Image(),
	IMG_crosshair : new CGL.image.Image(),
	IMG_grenadehair : new CGL.image.Image(),
	IMG_dog_icon : new CGL.image.Image(),
	IMG_migo_icon : new CGL.image.Image(),
	IMG_back_health : new CGL.image.Image(),
	IMG_migo_health : new CGL.image.Image(),
	IMG_dog_health : new CGL.image.Image(),
	IMG_treasure_icon_off : new CGL.image.Image(),
	IMG_treasure_icon_on : new CGL.image.Image(),
	IMG_amount_back : new CGL.image.Image(),
	IMG_titlescreen : new CGL.image.Image(),
	IMG_aboutscreen : new CGL.image.Image(),
	IMG_gameover_back : new CGL.image.Image(),
	
	IMG_tile_hidden : new CGL.image.Image(),
	IMG_tile_blank : new CGL.image.Image(),
	IMG_tile_dog : new CGL.image.Image(),
	IMG_tile_man : new CGL.image.Image(),
	IMG_tile_migo : new CGL.image.Image(),
	
	IMG_shop : new CGL.image.Image(),
	
	AUDIO_woof : new CGL.audio.Sample(),
	AUDIO_ouch : new CGL.audio.Sample(),
	AUDIO_shotgun : new CGL.audio.Sample(),
	AUDIO_grenade : new CGL.audio.Sample(),
	AUDIO_migo : new CGL.audio.Sample(),
	AUDIO_gameover : new CGL.audio.Sample(),
		
	init : function() {
		CGL.canvas.setDefault("TARGET_FPS", 60);
		CGL.canvas.createCanvas("canvas", 640, 480);
		CGL.event.initEventHandler();
		LD.ACTIVE_INTERVAL_ID = setInterval(LD.game.update, 1000/CGL.canvas.TARGET_FPS);
		for(var i = 0; i < LD.shop.WARES.length; i++)
		{
			LD.game.BTN_difficulty[i] = new CGL.ui.Button(192, 240 + (i * 42), 256, 42, LD.shop.WARES[i].difficulty);
		}
		
		LD.game.IMG_loading.load("img/loading.png");
		LD.game.IMG_splash.load("img/splash.png");
		
		LD.game.BTN_shop.load(["img/shop_off.png", "img/shop_on.png"]);
		LD.game.BTN_newgame.load(["img/newgame_off.png", "img/newgame_on.png"]);
		LD.game.BTN_about.load(["img/about_off.png", "img/about_on.png"]);
		
		LD.game.RB_shell.load(["img/shell.png", "img/shell_over.png", "img/shell_active.png"]);
		LD.game.RB_grenade.load(["img/grenade.png", "img/grenade_over.png", "img/grenade_active.png"]);
		
		LD.game.RADIO_weapon.addButton(LD.game.RB_shell);
		LD.game.RADIO_weapon.addButton(LD.game.RB_grenade);
		LD.game.RADIO_weapon.init();
		
		LD.game.IMG_shell.load("img/shell.png");
		LD.game.IMG_shell_active.load("img/shell_active.png");
		LD.game.IMG_grenade.load("img/grenade.png");
		LD.game.IMG_grenade_active.load("img/grenade_active.png");
		LD.game.IMG_dog.load("img/dog.png");
		LD.game.IMG_statusbar.load("img/statusbar.png");
		LD.game.IMG_statusback.load("img/statusback.png");
		LD.game.IMG_sideback.load("img/sideback.png");
		LD.game.IMG_crosshair.load("img/crosshair.png");
		LD.game.IMG_grenadehair.load("img/grenadehair.png");
		LD.game.IMG_dog_icon.load("img/dog_icon.png");
		LD.game.IMG_migo_icon.load("img/migo_icon.png");
		LD.game.IMG_back_health.load("img/back_health.png");
		LD.game.IMG_migo_health.load("img/migo_health.png");
		LD.game.IMG_dog_health.load("img/dog_health.png");
		LD.game.IMG_treasure_icon_off.load("img/treasure_icon_off.png");
		LD.game.IMG_treasure_icon_on.load("img/treasure_icon_on.png");
		LD.game.IMG_amount_back.load("img/amount_back.png");
		LD.game.IMG_titlescreen.load("img/titlescreen.png");
		LD.game.IMG_aboutscreen.load("img/about_text.png");
		LD.game.IMG_gameover_back.load("img/gameover_back.png");
		
		LD.game.IMG_tile_hidden.load("img/tile_hidden.png");
		LD.game.IMG_tile_blank.load("img/tile_blank.png");
		LD.game.IMG_tile_dog.load("img/tile_dog.png");
		LD.game.IMG_tile_man.load("img/tile_man.png");
		LD.game.IMG_tile_migo.load("img/tile_migo.png");
		
		LD.game.IMG_shop.load("img/shop_off.png");
		
		CGL.audio.checkCapabilities();
		if(CGL.audio.CAN_PLAY_AUDIO)
		{
			LD.game.AUDIO_woof.load("audio/woff");
			LD.game.AUDIO_ouch.load("audio/ouch");
			LD.game.AUDIO_shotgun.load("audio/shotgun");
			LD.game.AUDIO_grenade.load("audio/grenade");
			LD.game.AUDIO_migo.load("audio/migo");
			LD.game.AUDIO_gameover.load("audio/gameover");
		}
	},
	
	update : function() {
		LD.game.render();
		if(!LD.game.LOADED)
		{
			LD.game.LOADED = CGL.resources.getFinishedLoading();
		}
		else
		{
			switch(LD.game.GAME_STATE) {
			case 0:
				LD.update.updateMenu();
				break;
			case 1:
				LD.update.updateAbout();
				break;
			case 2:
				LD.update.updateGame();
				break;
			case 3:
				LD.update.updateGame();
				break;
			case 4:
				LD.update.updateShop();
				break;
			default:
				LD.update.updateMenu();
				break;
			}
		}
	},
	
	render : function() {
		ctx = CGL.canvas.getContext();
		ctx.clearRect(0, 0, 640, 480);
		
		if(!LD.game.LOADED)
		{
			ctx.fillRect(0, 0, 640, 480);
			LD.game.IMG_splash.render(ctx, 192, 32);
			LD.game.IMG_loading.render(ctx, 208, 340);
		}
		else
		{
			switch(LD.game.GAME_STATE) {
			case 0:
				LD.render.renderMenu(ctx);
				break;
			case 1:
				LD.render.renderAbout(ctx);
				break;
			case 2:
				LD.render.renderGame(ctx);
				break;
			case 3:
				LD.render.renderGame(ctx);
				break;
			case 4:
				LD.render.renderShop(ctx);
				break;
			default:
				LD.render.renderMenu(ctx);
				break;
			}
		}
		//CGL.util.showFps(ctx);
	},
	
	enterAbout : function() {
		LD.game.GAME_STATE = 1;
	},
	
	initGame : function() {
		LD.game.PLAYER = new LD.player.Player();
		LD.game.SHOP = new LD.shop.Shop();
		LD.game.SHOP.init(0);
		LD.game.ENEMYZONE = new LD.enemyzone.EnemyZone();
		LD.game.ENEMYZONE.init();
		LD.enemyzone.generateEnemyZone(10, 2);
		LD.game.PLAYER.dogs -= 1;
		LD.game.DOG = 10;
		LD.game.MI_GO = 10;
		LD.game.TREASURE = 2;
		
		LD.game.GAME_STATE = 2;
	},
	
	nextLvl : function() {
		LD.game.ENEMYZONE = new LD.enemyzone.EnemyZone();
		LD.game.ENEMYZONE.init();
		LD.enemyzone.generateEnemyZone(10, 2);
		
		if(LD.game.TREASURE == 0)
		{
			LD.game.PLAYER.dogs += 4;
			LD.game.PLAYER.grenades += 1;
		}
		else if(LD.game.TREASURE == 1)
		{
			LD.game.PLAYER.dogs +=2;
		}
		else
		{
			LD.game.PLAYER.dogs += 1;
		}
		
		LD.game.PLAYER.grenades += 1;
		
		LD.game.DOG = 10;
		LD.game.MI_GO = 10;
		LD.game.TREASURE = 2;
		LD.game.SHOP_OPEN = false;
		
		LD.game.GAME_STATE = 2;
		LD.game.PLAYER.nextLevel();
	},
	
	gotoShop : function() {
		LD.game.GAME_STATE = 4;
	},
	
	purchaseItem : function(item) {
		var price, quant;
		if(item == 0)
		{
			price = LD.game.SHOP.dogPrice;
			quant = LD.game.SHOP.dogs;
			if(LD.game.PLAYER.getMoney() >= price && quant > 0)
			{
				LD.game.PLAYER.addDog();
				LD.game.SHOP.removeDog();
				LD.game.PLAYER.removeMoney(price);
			}
		}
		else if(item == 1)
		{
			price = LD.game.SHOP.shellPrice;
			quant = LD.game.SHOP.shells;
			if(LD.game.PLAYER.getMoney() >= price && quant > 0)
			{
				LD.game.PLAYER.addShells();
				LD.game.SHOP.removeShells();
				LD.game.PLAYER.removeMoney(price);
			}
		}
		else
		{
			price = LD.game.SHOP.grenadePrice;
			quant = LD.game.SHOP.grenades;
			if(LD.game.PLAYER.getMoney() >= price && quant > 0)
			{
				LD.game.PLAYER.addGrenade();
				LD.game.SHOP.removeGrenade();
				LD.game.PLAYER.removeMoney(price);
			}
		}
	},
	
	chooseWeapon : function(choice) {
		LD.game.WEAPON = choice;
	}
};

LD.render = {
	renderMenu : function(ctx) {
		LD.game.IMG_titlescreen.render(ctx, 0, 0);
		ctx.font = "Bold 26px Times New Roman";
		LD.game.BTN_newgame.render(ctx);
		LD.game.BTN_about.render(ctx);
	},
		
	renderAbout : function(ctx) {
		LD.game.IMG_titlescreen.render(ctx, 0, 0);
		LD.game.IMG_aboutscreen.render(ctx, 8, 128);
	},
		
	renderGame : function(ctx) {
		var tileid;
		ctx.strokeRect(0, 0, 512, 384);
		
		for(var i = 0; i < 8; i++)
		{
			for(var j = 0; j < 6; j++)
			{
				tileid = LD.game.ENEMYZONE.tilemap.getTileId(i, j);
				
				if(LD.game.ACTIVEX == i && LD.game.ACTIVEY == j)
				{
					ctx.strokeStyle = "green";
				}
					ctx.fillRect(64 * i, 64 * j, 64, 64);
					ctx.font = "Bold 12px Times New Roman";
					ctx.fillStyle = "white";
					switch(tileid) {
					case 0:
						ctx.fillText("Hidden", 32 + 64 * i, 32 + 64 * j);
						LD.game.IMG_tile_hidden.render(ctx, 64 * i, 64 * j);
						break;
					case 1:
						ctx.fillText("Mi-Go", 32 + 64 * i, 32 + 64 * j);
						LD.game.IMG_tile_hidden.render(ctx, 64 * i, 64 * j);
						break;
					case 2:
						ctx.fillText("Dog", 32 + 64 * i, 32 + 64 * j);
						LD.game.IMG_tile_hidden.render(ctx, 64 * i, 64 * j);
						break;
					case 3:
						ctx.fillText("Man", 32 + 64 * i, 32 + 64 * j);
						LD.game.IMG_tile_hidden.render(ctx, 64 * i, 64 * j);
						break;
					case 4:
						LD.game.IMG_tile_migo.render(ctx, 64 * i, 64 * j);
						break;
					case 5:
						LD.game.IMG_tile_dog.render(ctx, 64 * i, 64 * j);
						break;
					case 6:
						LD.game.IMG_tile_man.render(ctx, 64 * i, 64 * j);
						break;
					case 7:
						LD.game.IMG_tile_blank.render(ctx, 64 * i, 64 * j);
						break;
					default:
					
					}
					ctx.fillStyle = "black";
				
					ctx.strokeStyle = "black";
					
					
				if(LD.game.ACTIVEX == i && LD.game.ACTIVEY == j)
				{
					if(LD.game.WEAPON == 0)
					{
						LD.game.IMG_crosshair.render(ctx, 64 * i, 64 * j);
					}
					else
					{
						LD.game.IMG_grenadehair.render(ctx, 64 * i, 64 * j);
					}
				}
			}
		}
		
		ctx.fillText(LD.game.PLAYER.dogs, 576, 64);
		
		ctx.fillText(LD.game.DOG, 64, 400);
		ctx.fillText(LD.game.MI_GO, 128, 400);
		ctx.fillText(LD.game.TREASURE, 192, 400);
		
		if(LD.game.GAME_STATE == 3)
		{
			LD.game.IMG_gameover_back.render(ctx, 192, 128);
			ctx.fillStyle = "white";
			ctx.fillText("GAME OVER!", 256, 214);
			ctx.fillText("You reached Level", 256, 230);
			ctx.fillText(LD.game.PLAYER.level + 1, 256, 248);
			ctx.fillStyle = "black";
		}
		
		LD.game.IMG_sideback.render(ctx, 512, 0);
		
		LD.game.IMG_dog.render(ctx, 512, 0);
		
		LD.game.RADIO_weapon.render(ctx);
		
		ctx.fillStyle = "white";
		ctx.font = "Bold 22px Times New Roman";
		ctx.textAlign = "center";
		
		LD.game.IMG_amount_back.render(ctx, 588, 84);
		ctx.fillText(LD.game.PLAYER.dogs, 612, 112);
		
		LD.game.IMG_amount_back.render(ctx, 588, 340);
		ctx.fillText(LD.game.PLAYER.grenades, 612, 368);
		
		for(var i = 0; i < 7; i++)
		{
			LD.game.IMG_statusback.render(ctx, 96 * i, 384);
		}
		
		LD.game.IMG_dog_icon.render(ctx, 4, 432);
		LD.game.IMG_back_health.render(ctx, 48, 432);
		LD.game.IMG_dog_health.renderSpec(ctx, 0, 0, 8 + 4 * (LD.game.DOG * 2), 44, 48, 432, 8 + 4 * (LD.game.DOG * 2), 44);
		
		LD.game.IMG_migo_icon.render(ctx, 208, 432);
		LD.game.IMG_back_health.render(ctx, 252, 432);
		LD.game.IMG_migo_health.renderSpec(ctx, 0, 0, 8 + 4 * (LD.game.MI_GO * 2), 44, 252, 432, 8 + 4 * (LD.game.MI_GO * 2), 44);
		
		if(LD.game.TREASURE == 1)
		{
			LD.game.IMG_treasure_icon_on.render(ctx, 412, 432);
			LD.game.IMG_treasure_icon_off.render(ctx, 460, 432);
		}
		else if(LD.game.TREASURE == 0)
		{
			LD.game.IMG_treasure_icon_on.render(ctx, 412, 432);
			LD.game.IMG_treasure_icon_on.render(ctx, 460, 432);
		}
		else
		{
			LD.game.IMG_treasure_icon_off.render(ctx, 412, 432);
			LD.game.IMG_treasure_icon_off.render(ctx, 460, 432);
		}
		
		if(LD.game.SHOP_OPEN)
		{
			LD.game.BTN_shop.render(ctx);
		}
		
		//LD.game.IMG_shop.render(ctx, 508, 428);
	},
		
	renderShop : function(ctx) {
		ctx.fillText("Shop till you Drop!", 320, 32);
		ctx.fillText("Your funds: " + LD.game.PLAYER.getMoney(), 320, 64);
		
		ctx.fillText("Available Dogs: " + LD.game.SHOP.dogs, 128, 128);
		ctx.fillText("Available Shells: " + LD.game.SHOP.shells, 128, 192);
		ctx.fillText("Available Grenades: " + LD.game.SHOP.grenades, 128, 256);
		
		LD.game.BTN_shopitem[0].render(ctx);
		LD.game.BTN_shopitem[1].render(ctx);
		LD.game.BTN_shopitem[2].render(ctx);
		
		LD.game.BTN_nextLvl.render(ctx);
	}
};

LD.update = {
	updateMenu : function(ctx) {
		LD.game.BTN_newgame.update(LD.game.initGame);
		LD.game.BTN_about.update(LD.game.enterAbout);
	},
			
	updateAbout : function(ctx) {
		if(CGL.event.MB_DOWN)
		{
			CGL.event.MB_DOWN = false;
			LD.game.GAME_STATE = 0;
		}
	},
			
	updateGame : function(ctx) {
		var activeTile;
		if(LD.game.GAME_STATE == 2)
		{
			if(CGL.event.MOUSEX < 512 && CGL.event.MOUSEX > 0 && CGL.event.MOUSEY < 384 && CGL.event.MOUSEY > 0)
			{
				
				LD.game.ACTIVEX = 64 * (CGL.event.MOUSEX / 64) - (CGL.event.MOUSEX % 64);
				LD.game.ACTIVEY = 64 * (CGL.event.MOUSEY / 64) - (CGL.event.MOUSEY % 64);
				LD.game.ACTIVEX /= 64;
				LD.game.ACTIVEY /= 64;
				
				if(CGL.event.MB_DOWN)
				{
					CGL.event.MB_DOWN = false;
					if(LD.game.WEAPON == 0)
					{
						LD.game.AUDIO_shotgun.play();
						activeTile = LD.game.ENEMYZONE.tilemap.getTileId(LD.game.ACTIVEX, LD.game.ACTIVEY);
						switch(activeTile) {
						case 0:
							LD.game.ENEMYZONE.tilemap.setTileId(LD.game.ACTIVEX, LD.game.ACTIVEY, 7);
							
							if(LD.game.DOG > 0)
							{
								LD.game.DOG -= 1;
							}
							else
							{
								LD.game.ENEMYZONE.killDog();
								LD.game.PLAYER.killDog();
								if(LD.game.PLAYER.getDogs() >= 0)
								{
									LD.enemyzone.addNewDog();
									LD.game.DOG = 10;
									LD.game.AUDIO_woof.play();
								}
								else
								{
									LD.game.GAME_STATE = 3;
									LD.game.AUDIO_gameover.play();
								}
							}
							break;
						case 1:
							LD.game.ENEMYZONE.tilemap.setTileId(LD.game.ACTIVEX, LD.game.ACTIVEY, 4);
							LD.game.MI_GO -= 1;
							LD.game.PLAYER.addMoney(10);
							LD.game.AUDIO_migo.play();
							if(LD.game.MI_GO == 0)
							{
								LD.game.SHOP_OPEN = true;
							}
							break;
						case 2:
							LD.game.ENEMYZONE.tilemap.setTileId(LD.game.ACTIVEX, LD.game.ACTIVEY, 5);
							LD.game.PLAYER.killDog();
							LD.game.AUDIO_woof.play();
							if(LD.game.PLAYER.getDogs() >= 0)
							{
								LD.enemyzone.addNewDog();
								LD.game.DOG = 10;
							}
							else
							{
								LD.game.GAME_STATE = 3;
								LD.game.AUDIO_gameover.play();
							}
							break;
						case 3:
							LD.game.ENEMYZONE.tilemap.setTileId(LD.game.ACTIVEX, LD.game.ACTIVEY, 6);
							LD.game.TREASURE -= 1;
							LD.game.PLAYER.addMoney(50);
							LD.game.AUDIO_ouch.play();
							if(LD.game.MI_GO == 0 && LD.game.TREASURE == 0)
							{
								LD.game.nextLvl();
							}
							break;
						default:
						}
					}
					else if(LD.game.PLAYER.grenades > 0 && LD.game.WEAPON == 1)
					{
						LD.game.PLAYER.grenades -= 1;
						LD.game.AUDIO_grenade.play();
						var dogDead, kills, tileX, tileY;
						tileX = LD.game.ACTIVEX-1;
						tileY = LD.game.ACTIVEY-1;
						for(var i = 0; i < 3; i++)
						{
							for(var j = 0; j < 3; j++)
							{
								if(tileX >= 0 && tileX < 8 && tileY >= 0 && tileY < 6)
								{
									activeTile = LD.game.ENEMYZONE.tilemap.getTileId(tileX, tileY);
									switch(activeTile) {
									case 0:
										LD.game.ENEMYZONE.tilemap.setTileId(tileX, tileY, 7);
										break;
									case 1:
										LD.game.ENEMYZONE.tilemap.setTileId(tileX, tileY, 4);
										LD.game.MI_GO -= 1;
										LD.game.PLAYER.addMoney(10);
										LD.game.AUDIO_migo.play();
										if(LD.game.MI_GO == 0)
										{
											LD.game.SHOP_OPEN = true;
										}
										kills += 1;
										break;
									case 2:
										LD.game.ENEMYZONE.tilemap.setTileId(tileX, tileY, 5);
										dogDead = true;
										LD.game.AUDIO_woof.play();
										break;
									case 3:
										LD.game.ENEMYZONE.tilemap.setTileId(tileX, tileY, 6);
										LD.game.TREASURE -= 1;
										kills += 1;
										LD.game.PLAYER.addMoney(50);
										LD.game.AUDIO_ouch.play();
										if(LD.game.MI_GO == 0 && LD.game.TREASURE == 0)
										{
											LD.game.nextLvl();
										}
										break;
									default:
									}
								}
								tileY += 1;
							}
							tileX += 1;
							tileY = LD.game.ACTIVEY - 1;
						}
						if(dogDead)
						{
							LD.game.PLAYER.killDog();
							if(LD.game.PLAYER.getDogs() >= 0)
							{
								LD.enemyzone.addNewDog();
								LD.game.DOG = 10;
							}
							else
							{
								LD.game.GAME_STATE = 3;
								LD.game.AUDIO_gameover.play();
							}
						}
						if(kills == 0)
						{
							if(LD.game.DOG > 0)
							{
								LD.game.DOG -= 1;
							}
							else
							{
								LD.game.ENEMYZONE.killDog();
								LD.game.PLAYER.killDog();
								if(LD.game.PLAYER.getDogs() >= 0)
								{
									LD.enemyzone.addNewDog();
									LD.game.DOG = 10;
								}
								else
								{
									LD.game.GAME_STATE = 3;
									LD.game.AUDIO_gameover.play();
								}
							}
						}
					}
				}
			}
			LD.game.RADIO_weapon.update(LD.game.chooseWeapon);
		}
		else if(LD.game.GAME_STATE == 3)
		{
			if(CGL.event.MB_DOWN)
			{
				CGL.event.MB_DOWN = false;
				LD.game.GAME_STATE = 0;
			}
		}
		if(LD.game.SHOP_OPEN)
		{
			LD.game.BTN_shop.update(LD.game.nextLvl);
		}
	},
			
	updateShop : function(ctx) {
		LD.game.BTN_shopitem[0].update(LD.game.purchaseItem, 0);
		LD.game.BTN_shopitem[1].update(LD.game.purchaseItem, 1);
		LD.game.BTN_shopitem[2].update(LD.game.purchaseItem, 2);
		LD.game.BTN_nextLvl.update(LD.game.nextLevel);
	}	
};

LD.enemyzone = {

	EnemyZone : function() {
		var ez = {
			tilemap : new CGL.tile.map.TileMap(8, 6),
			
			init : function() {
				ez.tilemap.init();
			},
		
			killDog : function() {
				for(var i = 0; i < 8; i++)
				{
					for(var j = 0; j < 6; j++)
					{
						if(ez.tilemap.getTileId(i, j) == 2)
						{
							ez.tilemap.setTileId(i, j, 5);
						}
					}
				}
			}
		};
		return ez;
	},

	generateEnemyZone : function(e, t) {
		var enemies, treasures, dog;
		enemies = e;
		treasures = t;
		dog = 1;
		
		while(enemies > 0)
		{
			enemies = LD.enemyzone.randomizeTiles(enemies, 1);
		}
		while(treasures > 0)
		{
			treasures = LD.enemyzone.randomizeTiles(treasures, 3);
		}
		while(dog > 0)
		{
			dog = LD.enemyzone.randomizeTiles(dog, 2);
		}
	},
	
	randomizeTiles : function(amount, type) {
		for(var i = 0; i < 8; i++)
		{
			for(var j = 0; j < 6; j++)
			{
				if(LD.game.ENEMYZONE.tilemap.getTileId(i, j) == 0)
				{
					if(amount > 0 && LD.enemyzone.randomizer(16) == 1)
					{
						LD.game.ENEMYZONE.tilemap.setTileId(i, j, type);
						amount -= 1;
					}
				}
			}
		}
		return amount;
	},
	
	randomizeTilesOpen : function(amount, type) {
		for(var i = 0; i < 8; i++)
		{
			for(var j = 0; j < 6; j++)
			{
				if(LD.game.ENEMYZONE.tilemap.getTileId(i, j) == 7)
				{
					if(amount > 0 && LD.enemyzone.randomizer(16) == 1)
					{
						LD.game.ENEMYZONE.tilemap.setTileId(i, j, type);
						amount -= 1;
					}
				}
			}
		}
		return amount;
	},
	
	addNewDog : function() {
		var dog = 1;
		var hidden = LD.enemyzone.checkHidden();
		if(hidden)
		{
			while(dog > 0)
			{
				dog = LD.enemyzone.randomizeTiles(dog, 2);
			}
		}
		else
		{
			while(dog > 0)
			{
				dog = LD.enemyzone.randomizeTilesOpen(dog, 2);
			}
		}
	},
	
	checkHidden : function() {
		var hidden = false;
		for(var i = 0; i < 8; i++)
		{
			for(var j = 0; j < 6; j++)
			{
				if(LD.game.ENEMYZONE.tilemap.getTileId(i, j) == 0)
				{
					hidden = true;
				}
			}
		}
		return hidden;
	},
	
	randomizer : function(i) {
		return Math.floor(Math.random() * i);
	}
};

LD.player = {
	Player : function() {
		var player = {
			dogs : 7,
			shells : 20,
			grenades : 2,
			money : 500,
			level : 0,
			kitten : false,
			
			init : function() {
				
			},
		
			killDog : function() {
				player.dogs -= 1;
			},
			
			getDogs : function() {
				return player.dogs;
			},
			
			getShells : function() {
				return player.shells;
			},
			
			getGrenades : function() {
				return player.grenades;
			},
			
			getMoney : function() {
				return player.money;
			},
			
			removeMoney : function(amount) {
				player.money -= amount;
			},
			
			addMoney : function(amount) {
				player.money += amount;
			},
			
			addDog : function() {
				player.dogs += 1;
			},
			
			addShells : function() {
				player.shells += 20;
			},
			
			addGrenade : function() {
				player.grenades += 1;
			},
			
			nextLevel : function() {
				player.level += 1;
			}
		};
		return player;
	}
};

LD.shop = {
	WARES : [{difficulty : "Easy", dogs : 20, dogPrice : 50, shells : 200, shellPrice : 10, grenades : 20, grenadePrice : 50},
	         {difficulty : "Normal", dogs : 10, dogPrice : 100, shells : 100, shellPrice : 20, grenades : 10, grenadePrice : 70},
	         {difficulty : "Hard", dogs : 5, dogPrice : 150, shells : 100, shellPrice : 30, grenades : 5, grenadePrice : 100}],
	
	Shop : function() {
		var shop = {
			dogs : 0,
			shells : 0,
			grenades : 0,
			dogPrice : 0,
			shellPrice : 0,
			grenadePrice : 0,
			
			init : function(difficulty) {
				shop.dogs = LD.shop.WARES[difficulty].dogs;
				shop.dogPrice = LD.shop.WARES[difficulty].dogPrice;
				shop.shells = LD.shop.WARES[difficulty].shells;
				shop.shellPrice = LD.shop.WARES[difficulty].shellPrice;
				shop.grenades = LD.shop.WARES[difficulty].grenades;
				shop.grenadePrice = LD.shop.WARES[difficulty].grenadePrice;
			},
		
			removeDog : function() {
				shop.dogs -= 1;
			},
			
			removeShells : function() {
				shop.shells -= 20;
			},
			
			removeGrenade : function() {
				shop.grenades -= 1;
			}
		};
		return shop;
	}
};